#include "DSC-100.h"

int* stuck;

LPCSTR szWindowClass = "DSC_100_EMU_CLASS";
LPCSTR szWindowTitle = "DSC-100 Emu 0.0.01";

void wndResizeByClient(HWND hWnd,int x,int y) {
	RECT size;
	RECT wndsize;
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,x+wndsize.right-size.right,y+wndsize.bottom-size.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam) {
	PAINTSTRUCT ps;
	HDC hdc;
	RECT rt;

	switch (message) {
		case WM_CREATE:
			// 60fps炢œƎv(x͒Ⴛ)
			SetTimer(hWnd,0,17,NULL);
			break;
		case WM_TIMER:
			InvalidateRect(hWnd,NULL,FALSE);
			SetTimer(hWnd,0,17,NULL);
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			SetDIBitsToDevice(hdc,0,0,XSIZE,YSIZE,0,0,0,YSIZE,
				(VOID*)getBmpData(),getBmi(),DIB_RGB_COLORS);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			KillTimer(hWnd,0);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
		LPSTR lpCmdLine,int nCmdShow) {
	// EBhE̍쐬
	MSG msg;
	WNDCLASSEX wcex;
	HWND hWnd;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(NULL,IDI_APPLICATION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	RegisterClassEx(&wcex);

	hWnd = CreateWindow(szWindowClass,
		szWindowTitle, WS_OVERLAPPEDWINDOW &
		~(WS_MAXIMIZEBOX | WS_THICKFRAME),
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd)return FALSE;

	wndResizeByClient(hWnd,XSIZE,YSIZE);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	// G~[^̏
	unsigned char *mem;
	struct REGS regs;

	mem = (unsigned char *) malloc(512 * 1024 * 1024);
	stuck = (int *) malloc(512 * 1024);
	init_disk(mem, (char*)"boot.img");
	init_regs(&regs);
	init_vram(mem);
	int i = *((char *)mem + DISKBUF);

	regs.ip = (unsigned int) DISKBUF;

	for(;;) {
		run_bin(&regs, mem);

		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			// XVvꂽXV
			if(msg.message==WM_PAINT)reflesh_vram(mem);
			else if(msg.message==WM_QUIT)break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return 0;
}
